searchNodes=[{"ref":"Mix.Tasks.Check.html","title":"Mix.Tasks.Check","type":"task","doc":"One task to efficiently run all code analysis &amp; testing tools in an Elixir project. How it works First it runs the compiler and aborts upon compilation errors (but not warnings). Further tools are run in parallel (unless --no-parallel option is passed) and their output is streamed one by one for instant insight. After all tools are completed, output from those that have failed gets reprinted for sake of easily reading into them all at once. Finally, a summary is presented with a list of all tools that have succeeded, failed or were skipped due to missing files or project dependencies (unless --no-skipped option is passed). Tools Following curated tools are configured by default: :compiler - produces compilation warnings that allow to early detect bugs &amp; typos in the code eg. an attempt to call non-existing or deprecated function :formatter - ensures that all the code follows the same basic formatting rules such as maximum number of chars in a line or function indentation :ex_unit - starts the application in test mode and runs all runtime tests against it (defined as test modules or embedded in docs as doctests) :credo - ensures that all the code follows a further established set of software design, consistency, readability &amp; misc rules and conventions (still statical) :sobelow - performs security-focused static analysis mainly focused on the Phoenix framework, but also detecting vulnerable dependencies in arbitrary Mix projects :dialyzer - performs static code analysis around type mismatches and other issues that are commonly detected by static language compilers :ex_doc - compiles the project documentation in order to ensure that there are no issues that would make it impossible for docs to get collected and assembled You can disable or adjust curated tools as well as add custom ones via the config file. Configuration file Check configuration may be adjusted with the optional .check.exs file. Task will load the configuration in following order: Default stock configuration. .check.exs in user home directory. .check.exs in umbrella root directory when called from sub-project. .check.exs in current project directory. Use the mix check.gen.config task to generate sample configuration that comes with well-commented examples to help you get started. Command line options --only dialyzer --only credo ... - run only specified check(s) --except dialyzer --except credo ... - don&#39;t run specified check(s) --no-skipped - don&#39;t print skipped tools in summary --no-exit-status - don&#39;t halt EVM to return non-zero exit status --no-parallel - don&#39;t run tools in parallel"},{"ref":"Mix.Tasks.Check.Gen.Config.html","title":"Mix.Tasks.Check.Gen.Config","type":"task","doc":"Generates optional configuration file (.check.exs) for adjusting the check."},{"ref":"readme.html","title":"ex_check","type":"extras","doc":"ex_check One task to efficiently run all code analysis &amp; testing tools in an Elixir project. There are following benefits from using this task: check consistency is achieved by running the same, established set of tools for the project by all developers - be it locally or on the CI server, as a Pull Request or deployment check reasonable defaults with a set of curated tools for effortlessly ensuring top code quality and taking the best out of the rich set of tools that the Elixir ecosystem has to offer shorter feedback loop thanks to compiling the project once and then running all the remaining tools in parallel while the output is streamed live during the check run reduced fixing iterations thanks to executing all the tools regardless of the failures of others and reprinting the errors from all of them at the end of the check run Read more and see demo on Cloudless Studio blog."},{"ref":"readme.html#getting-started","title":"ex_check - Getting started","type":"extras","doc":"Add ex_check to your list of dependencies in mix.exs: def deps do [ {:ex_check, &quot;&gt;= 0.0.0&quot;, only: [:dev, :test], runtime: false} ] end Optionally add curated tools to your list of dependencies in mix.exs: def deps do [ {:credo, &quot;&gt;= 0.0.0&quot;, only: :dev, runtime: false}, {:dialyxir, &quot;&gt;= 0.0.0&quot;, only: :dev, runtime: false}, {:ex_doc, &quot;&gt;= 0.0.0&quot;, only: :dev, runtime: false}, {:sobelow, &quot;&gt;= 0.0.0&quot;, only: :dev, runtime: false} ] end Run the check: mix check Optionally generate config to adjust the check: mix check.gen.config"},{"ref":"readme.html#continuous-integration","title":"ex_check - Continuous Integration","type":"extras","doc":"With mix check you can consistently run the same set of checks locally and on the CI. CI configuration also becomes trivial and comes out of the box with parallelism and error output from all checks at once regardless if previous one failed. Here&#39;s the minimal .travis.yml to get you started on Travis CI: language: elixir script: mix check If you use the dialyzer tool, you&#39;ll also want to cover PLT build timeouts and caching: # ... before_script: - travis_wait mix dialyzer --plt cache: directories: - _build - deps"},{"ref":"readme.html#documentation","title":"ex_check - Documentation","type":"extras","doc":"Learn more about the task workflow, included tools, configuration and options: mix help check Read docs for mix check on HexDocs: latest version."}]